Package org.xnio.conduits

# Class BlockingStreamSourceConduit

java.lang.Object
org.xnio.conduits.AbstractConduit<StreamSourceConduit>
org.xnio.conduits.AbstractSourceConduit<StreamSourceConduit>
org.xnio.conduits.AbstractStreamSourceConduit<StreamSourceConduit>
org.xnio.conduits.BlockingStreamSourceConduit

All Implemented Interfaces:
  `Conduit`, `SourceConduit`, `StreamSourceConduit`

public final class BlockingStreamSourceConduit extends AbstractStreamSourceConduit<StreamSourceConduit>
A stream source conduit which can switch into and out of blocking mode.

Author:
  David M. Lloyd

## Field Summary

### Fields inherited from class org.xnio.conduits.AbstractConduit

`next`

## Constructor Summary

Constructors
Constructor
Description
`BlockingStreamSourceConduit(StreamSourceConduit next)`
Construct a new instance.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`isReadResumed()`
Determine whether read notifications are currently enabled.
`int`
`read(ByteBuffer dst)`
Read a sequence of bytes from this conduit to the given buffer.
`long`
`read(ByteBuffer[] dsts, int offs, int len)`
Read a sequence of bytes from this conduit to the given buffers.
`void`
`resumeReads()`
Indicate that the conduit's `ReadReadyHandler` should be invoked as soon as data can be read without blocking.
`void`
`suspendReads()`
Indicate that calling the conduit's `ReadReadyHandler` should be suspended.
`long`
`transferTo(long position, long count, FileChannel target)`
Transfers bytes into the given file from this channel.
`long`
`transferTo(long count, ByteBuffer throughBuffer, StreamSinkChannel target)`
Transfers bytes into the given channel target.
`void`
`wakeupReads()`
Indicate that the conduit's `ReadReadyHandler` should be invoked immediately, and then again as soon as data can be read without blocking.

### Methods inherited from class org.xnio.conduits.AbstractSourceConduit

`awaitReadable, awaitReadable, getReadThread, isReadShutdown, setReadReadyHandler, terminateReads`

### Methods inherited from class org.xnio.conduits.AbstractConduit

`getWorker`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.xnio.conduits.Conduit

`getWorker`

### Methods inherited from interface org.xnio.conduits.SourceConduit

`awaitReadable, awaitReadable, getReadThread, isReadShutdown, setReadReadyHandler, terminateReads`

## Constructor Details

### BlockingStreamSourceConduit

public BlockingStreamSourceConduit(StreamSourceConduit next)
Construct a new instance.

Parameters:
  `next` - the delegate conduit to set

## Method Details

### transferTo

public long transferTo(long position, long count, FileChannel target) throws IOException
Description copied from interface: `StreamSourceConduit`
Transfers bytes into the given file from this channel.

Specified by:
  `transferTo` in interface `StreamSourceConduit`
Overrides:
  `transferTo` in class `AbstractStreamSourceConduit<StreamSourceConduit>`
Parameters:
  `position` - the position within the file from which the transfer is to begin
  `count` - the number of bytes to be transferred
  `target` - the file to write to
Returns:
  the number of bytes (possibly 0) that were actually transferred
Throws:
  `IOException` - if an I/O error occurs

### transferTo

public long transferTo(long count, ByteBuffer throughBuffer, StreamSinkChannel target) throws IOException
Description copied from interface: `StreamSourceConduit`
Transfers bytes into the given channel target. On entry, `throughBuffer` will be cleared. On exit, the buffer will be flipped for emptying, and may possibly be empty or may contain data. If this method returns a value less than `count`, then the remaining data in `throughBuffer` may contain data read from this channel which must be written to `target` to complete the operation.

Specified by:
  `transferTo` in interface `StreamSourceConduit`
Overrides:
  `transferTo` in class `AbstractStreamSourceConduit<StreamSourceConduit>`
Parameters:
  `count` - the number of bytes to be transferred
  `throughBuffer` - the buffer to copy through.
  `target` - the destination to write to
Returns:
  the number of bytes (possibly 0) that were actually transferred, or -1 if the end of input was reached
Throws:
  `IOException` - if an I/O error occurs

### read

public int read(ByteBuffer dst) throws IOException
Description copied from interface: `StreamSourceConduit`
Read a sequence of bytes from this conduit to the given buffer.

Specified by:
  `read` in interface `StreamSourceConduit`
Overrides:
  `read` in class `AbstractStreamSourceConduit<StreamSourceConduit>`
Returns:
  the number of bytes (possibly 0) that were actually transferred, or -1 if the end of input was reached or this conduit's `SourceConduit.terminateReads()` method was previously called
Throws:
  `IOException` - if an error occurs

### read

public long read(ByteBuffer[] dsts, int offs, int len) throws IOException
Description copied from interface: `StreamSourceConduit`
Read a sequence of bytes from this conduit to the given buffers.

Specified by:
  `read` in interface `StreamSourceConduit`
Overrides:
  `read` in class `AbstractStreamSourceConduit<StreamSourceConduit>`
Parameters:
  `offs` - the offset into the buffer array
  `len` - the number of buffers to fill
Returns:
  the number of bytes (possibly 0) that were actually transferred, or -1 if the end of input was reached or this conduit's `SourceConduit.terminateReads()` method was previously called
Throws:
  `IOException` - if an error occurs

### resumeReads

public void resumeReads()
Description copied from interface: `SourceConduit`
Indicate that the conduit's `ReadReadyHandler` should be invoked as soon as data can be read without blocking.

Specified by:
  `resumeReads` in interface `SourceConduit`
Overrides:
  `resumeReads` in class `AbstractSourceConduit<StreamSourceConduit>`

### wakeupReads

public void wakeupReads()
Description copied from interface: `SourceConduit`
Indicate that the conduit's `ReadReadyHandler` should be invoked immediately, and then again as soon as data can be read without blocking.

Specified by:
  `wakeupReads` in interface `SourceConduit`
Overrides:
  `wakeupReads` in class `AbstractSourceConduit<StreamSourceConduit>`

### suspendReads

public void suspendReads()
Description copied from interface: `SourceConduit`
Indicate that calling the conduit's `ReadReadyHandler` should be suspended.

Specified by:
  `suspendReads` in interface `SourceConduit`
Overrides:
  `suspendReads` in class `AbstractSourceConduit<StreamSourceConduit>`

### isReadResumed

public boolean isReadResumed()
Description copied from interface: `SourceConduit`
Determine whether read notifications are currently enabled.

Specified by:
  `isReadResumed` in interface `SourceConduit`
Overrides:
  `isReadResumed` in class `AbstractSourceConduit<StreamSourceConduit>`
Returns:
  `true` if read notifications are enabled